/**
 * 日历视图控制器对象
 */
var CalendarViewControllerBase = MDViewControllerBase.extend({
	construct: function(config) {
		arguments.callee.$.construct.call(this,config);
	},
	init:function(params){
		arguments.callee.$.init.call(this,params);
		var me = this;
		if(!me.searchform){
			me.calendar.load();
		}
	},
	onInit:function(){
		arguments.callee.$.onInit.call(this);
		var me = this;
		var dataurl = me.config.backendurl+'srfctrlid=calendar&SRFSUBAPP='+me.subapp+'&';
		var config = $.extend({id:this.getCId2()+'calendar',url:dataurl},me.config.ctrls.calendar);
		me.calendar = new IBizCalendar(config);
		me.calendar.on(IBizCalendar.ROWDBLCLICK, function(sender,args,e){
			var me = e.data;
    		me.onDataActivated(args,me.calendar);
        }, me);	
		me.calendar.on(IBizCalendar.CLICKDAY, function(sender,args,e){
			me.onNewData(args);
		}, me);	
		me.calendar.on(IBizCalendar.DELETEEVENT, function(sender,args,e){
			me.doRemove(args);
		}, me);	
		me.registerItem('calendar',this.tree);
	},
	getMDCtrl: function() {
		return this.getCalendar();
	},
	getCalendar:function(){
		return this.calendar;
	},
	/**
	 * 编辑数据
	 */
	onEditData: function(arg) {
		var me = this;
		var loadParam = {};
		if (me.getViewParam()) {
			$.extend(loadParam, me.getViewParam());
		}
		if (this.getParentMode()) {
			$.extend(loadParam, me.getParentMode());
		}
		if (this.getParentData()) {
			$.extend(loadParam, me.getParentData());
		}
		if (arg.srfcopymode) {
			$.extend(loadParam, {
				srfsourcekey: arg.data.id
			});
		} else {
			$.extend(loadParam, {srfkey: arg.data.id});
		}
		
		var editMode = me.getEditMode(arg.data);
		if (editMode) {
			loadParam.srfeditmode = editMode;
		}
		if(arg.data.srfmstag){
			loadParam.srfeditmode2 = arg.data.srfmstag;
		}
		
		loadParam.openerid = me.getId();
		me.doEditDataNormal(loadParam);
	},
	/**
	 * 新建数据
	 */
	onNewData: function(arg) {
		var me = this;
		var loadParam = {};
		if (me.getViewParam()) {
			$.extend(loadParam, me.getViewParam());
		}
		if (me.getParentMode()) {
			$.extend(loadParam, me.getParentMode());
		}
		if (me.getParentData()) {
			$.extend(loadParam, me.getParentData());
		}
		if(me.isInGridRowEdit){
			me.doNewRow(loadParam);
			return;
		}
		if (me.isEnableBatchAdd()) {
			me.doNewDataBatch(loadParam);
			return;
		}
		if (me.doNewDataWizard(loadParam)) {
			return;
		}
		if(arg.begintime) {
			$.extend(loadParam, {begintime: arg.begintime});
		}
		me.doNewDataNormal(loadParam);
	},
	 /*删除操作*/
    doRemove: function (params){
    	var me=this;
    	if(params && params.id){
    		//询问框
			IBiz.confirm($IGM('GRIDVIEWCONTROLLER.DOREMOVE.INFO','确认要删除数据，删除操作将不可恢复？'), function(result) {
				if(result){
					var arg = {srfitemid: params.id};
					if (me.getParentMode()) {
			             $.extend(arg, me.getParentMode());
			        }

			        if (me.getParentData()) {
			        	$.extend(arg, me.getParentData());
			        }
			        me.getMDCtrl().remove(arg);
				}
			});
    	}
     },
	/**
     * 值选中变化
     * @param sender 事件源
     * @param args 参数
     * @param e 事件
     */
    onSelectionChange: function (item,args) {
        var me = this;
        if (args.length > 0) {
            var record = args[0].original.tag;
            var selectedData = {srfkey:record.srfkey,srfmajortext:record.srfmajortext};
            me.selectedData = selectedData;
            
            me.selectedDatas = [];
            $.each(args,function(index,item){
            	 var record = item.original.tag;
            	var selectedData = {srfkey:record.srfkey,srfmajortext:record.srfmajortext};
            	if(index == 0){
            		me.selectedData = selectedData;
            	}
            	 me.selectedDatas.push(selectedData);
            });
        }else {
            me.selectedData = null;
            me.selectedDatas = null;
        }
        arguments.callee.$.onSelectionChange.call(this,item,me.selectedDatas);
    }
});