/**
 * 多数据视图控制器对象
 */
var GridView8ControllerBase = GridViewControllerBase.extend({
	construct: function(config) {
		arguments.callee.$.construct.call(this,config);
	},
	/**
	 * 初始化
	 */
	init:function(params){
		arguments.callee.$.init.call(this,params);
		var me = this;
		if(me.getMDCtrl() &&　me.gridWidth){
			me.getMDCtrl().grid.parents(".ibiz-grid-right").width(me.gridWidth);
			if(me.getTotalGrid()){
				if(me.totalGridWidth){
					me.getTotalGrid().grid.parents(".ibiz-grid-left").width(me.totalGridWidth);
				}else{
					me.getTotalGrid().grid.parents(".ibiz-grid-left").css("width","calc(100% - "+me.gridWidth+"px - 70px)");
				}
			}
		}else if(me.getTotalGrid() && me.totalGridWidth){
			me.getTotalGrid().grid.parents(".ibiz-grid-left").width(me.totalGridWidth);
			if(me.getMDCtrl()){
				me.getMDCtrl().grid.parents(".ibiz-grid-right").css("width","calc(100% - "+me.totalGridWidth+"px - 70px)");
			}
		}
		if(me.totalGridHeight || me.totalGridHeight){
			var totalGridHeight = me.totalGridHeight?me.totalGridHeight:0;
			var gridHeight = me.gridHeight?me.gridHeight:0;
			$("."+this.getCId2()+"move-toolbar").height(totalGridHeight>gridHeight?totalGridHeight:gridHeight);
		}else {
			$("."+this.getCId2()+"move-toolbar").height(300);
		}
		if(me.totalsearchform){
			me.totalsearchform.init();
			if(me.config.loaddefault != undefined && me.config.loaddefault){
				me.totalsearchform.autoLoad(me.viewparam);
			}
//			if(me.hasQuickSearch() == true){
//				me.totalsearchform.close();
//			}else{
				me.totalsearchform.open();
//			}
		}else{
			me.onTotalSearchFormOpen({height: 0});
		}
		if(me.searchform){
			me.searchform.open();
		}
		me.doLayout();
		
		if(!me.totalsearchform){
			me.totaldatagrid.load();
		}
	},
	/**
	 * 执行初始化
	 */
	onInit:function(){
		arguments.callee.$.onInit.call(this);
		var me = this;
		
		if(me.hasHtmlElement('totalgrid')){
			var dataurl = me.config.backendurl+'srfctrlid=totalgrid&SRFSUBAPP='+me.subapp+'&';
			//初始化主表格
			var dgCfg = $.extend({id:this.getCId2()+'totalgrid',url:dataurl,ctrler:me},me.config.ctrls.totalgrid);
			dgCfg.multiselect=me.isEnableMultiSelect();
			if(dgCfg.width && dgCfg.width>0){
				me.totalGridWidth = dgCfg.width;
			}
			if(dgCfg.height && dgCfg.height>0){
				me.totalGridHeight = dgCfg.height;
			}
			me.totaldatagrid = me.createGrid(dgCfg);
			me.totaldatagrid.on(IBizDataGrid.ROWDBLCLICK, function(sender,args,e){
				var me = e.data;
	    		me.onDataActivated(args,e);
	        }, me);	
			me.totaldatagrid.on(IBizDataGrid.SELECTIONCHANGE, function(sender, args, e) {
				me.onSelectionChange(sender, args);
			}, me);
			me.totaldatagrid.on(IBizDataGrid.BEFORELOAD, function(sender, args, e) {
				me.onTotalStoreBeforeLoad(sender, args,e);
			}, me);
			me.totaldatagrid.on(IBizDataGrid.LOADED, function(sender, args, e) {
				me.onStoreLoad(sender, args,e);
			}, me);
			me.registerItem('totalgrid',me.totaldatagrid);
		}
		//初始化搜索面板
		me.initTotalSearchForm();
		me.doLayout();
		
		$("#"+this.getCId2()+"moveLeft>img").click(function(){
			me.removeData();
		});
		$("#"+this.getCId2()+"moveRight>img").click(function(){
			var selections = me.getTotalGrid().getSelection();
			me.addDataBatch(selections);
		});
		$("#"+this.getCId2()+"moveAllLeft>img").click(function(){
			me.removeAllData();
		});
		$("#"+this.getCId2()+"moveAllRight>img").click(function(){
			var allData = me.getTotalGrid().getAllData();
			me.addDataBatch(allData);
		});
	},
	initTotalSearchForm: function(){
		var me = this;
		//初始化搜索面板
		if(me.hasHtmlElement('totalsearchform')){
			var dataurl = me.getBackendUrl()+'srfctrlid=totalsearchform&SRFSUBAPP='+me.subapp+'&';
			var sfCfg = $.extend({id:this.getCId2()+'totalsearchform',url:dataurl,ctrler: me},me.config.ctrls.totalsearchForm);
			sfCfg.showSearchBtn = true;
			me.totalsearchform = me.createSearchForm(sfCfg);
			me.registerItem('totalsearchform',me.totalsearchform);
			me.totalsearchform.on(IBizSearchForm.FORMSEARCHED, function(sender, args, e) {
				me.onTotalSearchFormSearched();
			}, me);
			me.totalsearchform.on(IBizSearchForm.FORMRESETED, function(sender, args, e) {
				me.onTotalSearchFormReseted();
			}, me);
			me.totalsearchform.on(IBizSearchForm.FORMCONTRACT, function(sender, args, e) {
				me.onTotalSearchFormOpen(args);
			}, me);
			me.totalsearchform.on(IBizForm.FORMFIELDCHANGED, function(sender, args, e) {
				var fieldname = '';
				if (sender != null) fieldname = sender.getName();
				if (!args) args = {};
				me.onSearchFormFieldChanged(fieldname, sender, args.newvalue, args.oldvalue);
			}, me);
		}
	},
	onTotalSearchFormOpen: function(args){
		var me = this;
		if(me.getTotalGrid()){
			me.getTotalGrid().reSetHeight(args.height-34);
		}
	},
	onTotalSearchFormSearched: function() {
		if (this.getTotalGrid()) {
			this.getTotalGrid().load();
		}
	},
	onTotalSearchFormReseted: function() {
		if (this.getTotalGrid()) {
			this.getTotalGrid().load();
		}
	},
	onAddBatched: function(sender,args,e){
		var me = this;
		me.getTotalGrid().refresh();
	},
	onStoreRemove: function(sender, args,e){
		var me = this;
		me.getTotalGrid().refresh();
	},
	getTotalSearchForm:function(){
		return this.totalsearchform;
	},
	createTotalGrid:function(config){
		return IBiz.createGrid(config);
	},
	getTotalGrid: function(){
		var me = this;
		return me.totaldatagrid;
	},
	setSize:function(width,height){
		arguments.callee.$.setSize.call(this,width,height);
	},
	/**
	 * 数据加载之前
	 */
	onTotalStoreBeforeLoad: function(sender, args, e) {
		var me = this;
        var fetchParam = {};
        if (me.viewparam){
        	$.extend(fetchParam,me.viewparam);
        }
//        if (me.getParentMode()) {
//        	$.extend(fetchParam, me.getParentMode());
//        }
        if (me.getParentData()) {
        	$.extend(fetchParam, me.getParentData());
        }
        if ((me.getTotalSearchCond() && me.totalsearchform.isOpen()) || !me.hasQuickSearch()) {
        	$.extend(fetchParam, me.getTotalSearchCond());
        }
        //是否有自定义查询
        if (me.totalsearchform && me.totalsearchform.isCustomSearch()) {
        	$.extend(fetchParam, me.totalsearchform.getCustomSearchVal());
        }
        //获取快速搜索里的搜索参数
        if(me.hasQuickSearch() && me.quickSearch){
        	args['search'] = me.quickSearch.val();
        }
        $.extend(args, fetchParam,{ srfaction: 'fetch',SRFSUBAPP:me.subapp });
	},
	getTotalSearchCond: function() {
		if (this.getTotalSearchForm()) {
			return this.getTotalSearchForm().getValues();
		}
		return null;
	},
	onRefresh: function() {
		arguments.callee.$.onRefresh.call(this);
		var me = this;
		if (me.getTotalGrid()) {
			me.getTotalGrid().load();
		}
	},
     /*编辑操作*/
     doEdit: function (params){
     	var me=this;
     	//获取要编辑的数据集合
		if(params && params.srfkey){
			if($.isFunction(me.getGrid().findItem)){
				params = me.getGrid().findItem('srfkey',params.srfkey);
			}
			var arg = {data: params};
			me.onEditData(arg);
			return;
		}
		
     	var  selectedData =  me.getGrid().getSelection() ;
     	if(selectedData==null||selectedData.length==0)
     		return;
      	 var arg = { data: selectedData[0] };
         me.onEditData(arg);
     },
     getBackendUIActionParam:function(uiaction){
    	 var me=this;
    	 if(uiaction.actiontarget=='SINGLEKEY' || uiaction.actiontarget=='MULTIKEY'){
    		 var  selectedData =  me.getGrid().getSelection() ;
    		 if(selectedData==null||selectedData.length==0)
    	    	return null;
    	    	
    		 var dataInfo = '';
    		 var keys = '';
    		 var firstOnly = (uiaction.actiontarget=='SINGLEKEY');
    		 $.each(selectedData, function(index, record) {  
    			 	var srfmajortext = record.srfmajortext;
 	    			var key = record.srfkey;
 	    			if(keys!='')
 		     		keys+=';';
 	    			keys += key;
 		     	
 	    			if(index<5)
 	    			{
 	    				if(dataInfo!='')
 	    					dataInfo+='、';
 	    				dataInfo+=srfmajortext;
 	    			}
 	    			if(firstOnly)
 	    				return false;
    		 });
    		 return {srfkeys:keys,srfkey:keys,dataInfo:dataInfo};
    	 }
    	 return {};
    },
});