/**
 * 
 */
var IBizFormGroup =  IBizField.extend({
	construct: function(config) {
		arguments.callee.$.construct.call(this,config);
		var me = this;
		me.field = $('#'+me.getUniqueId());
		
		me.dropDownLink = $('.'+me.getUniqueId()+'_ddl');
		me.dropDownTip = $('#'+me.getUniqueId()+'_ddt');
		me.dropDownImg = $('#'+me.getUniqueId()+'_ddi');
		
		me.groupDiv = $('#'+me.getUniqueId()+'_gd');
		
		//me.groupFa = $('a.'+me.getUniqueId()+"_"+config.name+" i");
		//me.downCloseMode = $('.'+me.getUniqueId()+"_"+config.name);
		//me.groupCloseMode = $('div.'+me.getUniqueId()+"_"+config.name);
		//me.closeContent = $("."+config.name+"_content");
		
		me.newAction = me.field.find('.donew');
		me.moreAction = me.field.find('.getmore');
		me.moreActionMenu = me.field.find('.dropdown_select');
		
		//分组标题关联字段
		me.captionDiv = me.field.find('.'+me.name+'_text')
		if(me.config.form){
			me.config.form.on(IBizForm.FORMLOADED, function(sender, args, e){
				if(me.config.captionItem) {
					me.setGroupText(me.config.captionItem);
				}
			});
			me.config.form.on(IBizForm.FORMSAVED, function(sender, args, e){
				if(me.config.captionItem) {
					me.setGroupText(me.config.captionItem);
				}
			});
		}
		
		//绑定新建操作事件
		me.newAction.click(function(){
			me.doNewAction();
		});
		//绑定更多操作事件
		me.moreAction.click(function(event){
			me.showMoreAction();
		});
		//执行更多操作行为事件
		me.moreActionMenu.on("click", "a", function(e){
			var uiaction = this.attributes.uiaction.nodeValue;
			me.doMoreAction(uiaction);
		});
		
		if(config.titleBarCloseMode == null || config.titleBarCloseMode == "0"){
			return;
		}
		var titleBarCloseMode = config.titleBarCloseMode;
		if(titleBarCloseMode == '1'){
			me.downState = true;
			me.dropDownTip.hide();
			me.dropDownImg.removeClass("fa-angle-double-down");
			me.dropDownImg.addClass("fa-angle-double-up");
		}else if(titleBarCloseMode == '2'){
			me.downState = false;
			me.groupDiv.hide();
			me.dropDownTip.show();
		}
		me.dropDownLink.click(function(event){
			if(me.downState){
				me.groupDiv.hide();
				me.dropDownTip.show();
				me.dropDownImg.removeClass("fa-angle-double-up");
				me.dropDownImg.addClass("fa-angle-double-down");
				me.downState = false;
			}else{
				me.groupDiv.show();
				me.dropDownTip.hide();
				me.dropDownImg.removeClass("fa-angle-double-down");
				me.dropDownImg.addClass("fa-angle-double-up");
				me.downState = true;
			}
		});

	},
	/**
	 * 执行更多行为操作
	 */
	doMoreAction: function(uiaction) {
		var me = this;
		var drpanel = me.form.findField(me.config.firstChild);
		drpanel.doMoreAction(uiaction);
	},
	/**
	 * 显示更多行为菜单
	 */
	showMoreAction: function(){
		var me = this;
		var drpanel = me.form.findField(me.config.firstChild);
		me.uiactions = drpanel.getMoreAction();
		var appendHTML = "";
      
		$.each(me.uiactions,function(){
			appendHTML += "<li><a id=moreActionMenu uiaction="+this.tag+" >"+this.title+"</a></li>";
		});

		me.moreActionMenu.html(appendHTML);
	},
	/**
	 * 执行新建行为操作
	 */
	doNewAction: function() {
		var me = this;
		var drpanel = me.form.findField(me.config.firstChild);
		drpanel.doNew();
	},
	/**
	 * 设置是否启用
	 */
	setDisabled:function(disabled){
		var me = this;
		me.disabled = disabled;
	},
	/**
	 * 隐藏控件
	 */
	setHidden:function(hidden){
		var me = this;
		me.hidden = hidden;
		if(me.field){
			if(hidden){
				me.field.addClass('hidden');
			}else
			{
				me.field.removeClass('hidden');
			}
		}
	},
	/**
	 * 设置可见性
	 */
	setVisible:function(visible){
		this.visible = visible;
		if(this.field)
		{
			if(visible){
				this.field.removeClass('hidden');
			}else{
				this.field.addClass('hidden');
			}
		}
	},
	/**
	 * 设置分组标题
	 */
	setGroupText: function(name){
		var me = this;
		var field = me.config.form.findField(name);
		if(field && me.captionDiv) {
			me.captionDiv.find("h5").html(field.getValue());
		}
	}
});