var IBizLeftToRight = IBizField.extend({
	construct: function(config){
		arguments.callee.$.construct.call(this,config);
		var me = this;
		me.items = [];
		me.field = $('#'+this.getUniqueId());
		me.load(config);
		me.orMode = config.orMode;
		me.valueSeparator = config.valueSeparator;
		if (me.orMode == undefined || me.orMode == '') {
	        me.orMode = 'str';
		}
		if (me.orMode == 'str' && (me.valueSeparator == undefined || me.valueSeparator == '')) {
	          me.valueSeparator = ',';
		}
		
		me.field.on("change",".lrcheckbox",function(e){
			$(e.target).parents("li").toggleClass("selected");
		});
		
		//搜索
		me.field.find(".ibiz-lefttoright-search").find("span").on('click','',function(e) {
			var direction = $(this).parent().attr("type");
			me.search(direction);
		});
		
		//选中
		me.field.find(".ibiz-lefttoright-add").on('click','',function(e) {
			var lis = me.field.find(".ibiz-lefttoright-left").find("li.selected");
			me.dealData(lis,"right");
		});
		//取消
		me.field.find(".ibiz-lefttoright-cancle").on('click','',function(e) {
			var lis = me.field.find(".ibiz-lefttoright-right").find("li.selected");
			me.dealData(lis,"left");
		});
		//全部选中
		me.field.find(".ibiz-lefttoright-addAll").on('click','',function(e) {
			if(me.disabled){
				return;
			}
			var lis = me.field.find(".ibiz-lefttoright-left").find("li");
			me.dealData(lis,"right");
		});
		//全部取消
		me.field.find(".ibiz-lefttoright-cancleAll").on('click','',function(e) {
			if(me.disabled){
				return;
			}
			var lis = me.field.find(".ibiz-lefttoright-right").find("li");
			me.dealData(lis,"left");
		});
		document.onkeydown=function(evt)
		{
			var key = evt.keyCode?evt.keyCode:evt.which;
			 if(key == 13){
				 var direction = $(evt.target).parent().attr("type");
				 me.search(direction);
			  }
		}
	},
	//搜索
	search:function(deirction){
		var me = this;
		me.field.find(".ibiz-lefttoright-"+deirction).find("li").hide();
		var tj = me.field.find(".ibiz-lefttoright-"+deirction).find("input")[0].value;
		if(!tj || tj==""){
			me.field.find(".ibiz-lefttoright-"+deirction).find("li").show();
		}else{
			me.field.find(".ibiz-lefttoright-"+deirction).find("li").each(function(){
				var content=$(this)[0].innerText;
				if(content.indexOf(tj)>0){
					$(this).show();
				}
			});
		}
	},
	//根据方向移动
	dealData:function(lis,direction){
		var me = this;
		for(var i=0;i<lis.length;i++){
			var param={} ;
			param.value=lis.eq(i).find(".lrcheckbox")[0].value;
			param.text = lis.eq(i).text().substring(2);
			me.moveItem(param,direction);
		}
		lis.remove();
		me.selection();
	},
	selection: function(){
		var me =this;
		var lis = me.field.find(".ibiz-lefttoright-right").find("li");
		if(me.orMode=='num'){
			var _tmp = 0;
			$.each(lis,function(index,item){
				var value=$(item).find(".lrcheckbox")[0].value;
				_tmp = _tmp | parseInt(value);
			});
			me.setValue(_tmp.toString());
		}else if(me.orMode=='str'){
			var vals = [];
			$.each(lis,function(index,item){
				var value=$(item).find(".lrcheckbox")[0].value;
				vals.push(value);
			})
			me.setValue(vals.join(me.valueSeparator));
		}
	},
	moveItem:function(param,direction){
		var me = this;
		if(param){
			var strLeft = "<li><input type='checkbox' class='lrcheckbox' value="+param.value+">&nbsp;&nbsp;"+param.text+"</li>";
			me.field.find(".ibiz-lefttoright-"+direction).find("ul").append(strLeft);
		}
	},
	/**
	 * 设置值
	 * @param value 值
	 */
	setValue:function(value){
		var me = this;
		me.isSetValue = true;
		var oldVal = me.value;
		me.value = value;
		if(oldVal != value){
			me.setAsyncConfig(me.dataConfig);
			me.onValueChanged(oldVal,value);
		}
	},
	load:function(config){
		if(!config){
			return;
		}
		var me = this;
		var fields = [];
		//绘制控件
		var height = 200;
		if(config.height){
			height = config.height;
		}
		me.field.height(height);
		if(!config.width || config.width==0){
			me.field.css("min-width","200px");
			me.field.find(".ibiz-lefttoright-option").css("min-width","30px");
		}else{
			me.field.width(config.width);
		}
		//默认不支持目标参数搜索
		if(config.leftSearch){
			me.field.find(".ibiz-lefttoright-left").find(".ibiz-lefttoright-search").show();
			me.field.find(".ibiz-lefttoright-left").find("div").eq(1).height("calc(100% - 50px)");
		}
		if(config.rightSearch){
			me.field.find(".ibiz-lefttoright-right").find(".ibiz-lefttoright-search").show();
			me.field.find(".ibiz-lefttoright-right").find("div").eq(1).height("calc(100% - 50px)");
		}
	},
	setAsyncConfig:function(config){
		var me = this;
		//默认不支持原参数搜索
		me.field.find("li").remove();
		var datas=[];
		if(config && config.items){
			me.dataConfig = config;
			if(!me.isSetValue){
				return;
			}
			if(me.value){
				if(me.orMode=='num'){
					 var nVal = parseInt(me.value);
					 $.each(config.items,function(idx,item){
						 var inputValue = parseInt(item.value);
						 if ((nVal & inputValue) == inputValue)
							 {
							 	datas.push(inputValue);
							 }
					 });
				}else if(me.orMode=='str'){
					datas=me.value.split(me.valueSeparator);
				}
			}	
			
				$.each(config.items,function(idx,item){
					var flag = true;
					for(var i=0;i<datas.length;i++){
						if(item.value==datas[i]){
							flag = false;
							me.moveItem(item,"right");
							break;
						}
					}
					if(flag){
						me.moveItem(item,"left");
					}
				});
			}
	},
	/**
	 * 设置是否启用
	 */
	setDisabled:function(disabled){
		var me = this;
		me.disabled = disabled;
		var checkboxs1 = me.field.find(".ibiz-lefttoright-left").find("li").find(".lrcheckbox");
		var checkboxs2 = me.field.find(".ibiz-lefttoright-right").find("li").find(".lrcheckbox");
		checkboxs1.prop("disabled", disabled);
		checkboxs2.prop("disabled", disabled);
		arguments.callee.$.setDisabled.call(this,disabled);
	},
});