/**
 * 树形下拉列表选择
 */
var IBizTreeField = IBizField.extend({
	construct: function(options) {
		arguments.callee.$.construct.call(this,options);
		var me = this;
		this.selectData = [];
		me.field = $('#'+me.getUniqueId());
		var multiple = true;
		if(options.multiple)
			multiple = options.multiple;
		
		var cascade = multiple?"down+up+undetermined":"undetermined";
		if(me.field){
			
			me.field.jstree({
			    core : {
					check_callback: true,
			    	multiple: multiple,
			    },
			    plugins: [ "checkbox"],
				checkbox: {
					visible: true,
					cascade:cascade, 
					three_state: false
				}
			});
			me.field.bind("activate_node.jstree", function (obj, e) {
				me.setValue(me.field.jstree(true).get_selected().toString());
			});
			me.field.bind('refresh.jstree',function (obj, e) {
				me.field.jstree('select_node',me.selectData);
				e.instance.open_node(me.selectData);
			});
		}
	},
	onValueChanged:function(oldValue,newValue){
		var me = this;
		me.field.val(newValue);
		me.selectData = newValue.split(',');
		arguments.callee.$.onValueChanged.call(me,oldValue,newValue);
	},
	/**
	 * 设置动态配置
	 */
	setAsyncConfig : function(config) {
		var me = this;
		
		if(me.field && config && config.items){
			var strItems = JSON.stringify(config.items).replace(/items/g,"children").replace(/"value"/g,"'id'").replace(/"/g,"'");
			if(strItems){
				config.items = eval(strItems);
				me.field.jstree(true).settings.core.data = config.items;
				me.field.jstree(true).refresh();
			}
		}
	}
});