/**
 * 向导面板
 */
var IBizWizardPanel = IBizControl.extend({
	construct: function(config) {
		arguments.callee.$.construct.call(this,config);
		var me = this;
		me.wizardItems = {};
		me.formIds = [];
		me.field = $("#"+config.id);
		me.backendUrl = config.ctrler.getBackendUrl();
		me.formActions = {};
	},
	init: function(){
		var me = this;
	},
	registerForm : function(cfg) {
		var me = this;
		if(me.hasHtmlElement(cfg.id)){
			var dataurl = me.backendUrl+'srfctrlid='+cfg.srfctrlid+'&SRFSUBAPP='+me.config.ctrler.subapp+'&';
			var form = me.createEditForm({id:cfg.id,url:dataurl,ctrler:cfg.ctrler});
			form.on(IBizForm.FORMSAVED, function(sender, args, e) {
				me.onFormSaved(args);
			}, me);
			form.on(IBizForm.FORMFIELDCHANGED, function(sender, args, e) {
				me.fireEvent(IBizForm.FORMFIELDCHANGED, me, sender);
			}, me);
			me.registerformItem(form);
			return form;
		}
	},
	registerformItem : function(form) {
		var me = this;
		if (form) {
			me.wizardItems[form.id] = form;
			me.formIds.push(form.id);
		}
	},
	registerformAction: function(formId,action){
		var me = this;
		if(!this.formActions[formId]){
			this.formActions[formId] = [];
		}
		this.formActions[formId].push(action);
	},
	getFormActions: function(formId){
		return this.formActions[formId];
	},
	getForm:function(id){
		var me = this;
		return me.wizardItems[id];
	},
	createEditForm:function(config){
    	return IBiz.createEditForm(config);
    },
    hasHtmlElement: function(id){
    	if($("#"+id).length>0)
    		return true;
    	return false;
    },
    onFormLoaded: function(){
    	
    },
    formLoad: function(param){
    	var me = this;
    },
    /**
	 * 表单保存完成
	 */
	onFormSaved: function(data) {
		var me = this;
		if(me.formIds.indexOf(me.curForm.id)+1 >= me.formIds.length){
			me.state = "finish";
		}
		if(me.state == "next"){
			var formId = me.formIds[me.formIds.indexOf(me.curForm.id)+1];
			me.jumpForm(formId);
		}else if(me.state == "finish"){
			me.state = "finish";
			var param = {srfaction:"finish"};
			param.srfkey = me.param.srfkey;
	    	IBiz.ajax({
	    		url: me.config.url,
	    		params: param,
	    		method:'POST',
	    		success: function(data){
	    			if(data.ret == 0){
	    				IBiz.processResultBefore(data);
	    				me.fireEvent(IBizWizardPanel.WIZARDFINISH, me, data);
	    				if (data.info && data.info != '') {
	    					IBiz.alert('',data.info,1);
	    				}
	    				IBiz.processResult(data);
	    			} else {
	    				IBiz.alert(data.errorMessage);
	    			}
	    		},
	    		error: function(){
	    			IBiz.alert("向导完成操作报错！");
	    		}
	    	});
		}
	},
	load: function(param) {
		var me = this;
		$.extend(param,{srfaction:"init"});
    	IBiz.ajax({
    		url: me.config.url,
    		params: param,
    		method:'POST',
    		success: function(data){
    			if(data.ret == 0){
    				me.param = data.data;
    				me.curForm = me.getForm(me.formIds[0]);
    				me.jumpForm(me.formIds[0]);
    			} else {
    				IBiz.alert(data.errorMessage);
    			}
    		},
    		error: function(){
    			IBiz.alert("向导面板加载报错！");
    		}
    	});
	},
	jumpForm: function(formId){
		var me = this;
		$("#"+me.curForm.id).parent().removeClass("active");
		me.curForm = me.getForm(formId);
		$("#"+me.curForm.id).parent().addClass("active");
		me.fireEvent(IBizWizardPanel.WIZARDFORMCHANGE, me, {formId:me.curForm.id});
		me.curForm.init();
		me.curForm.load2(me.param);
	},
	goNext: function() {
		var me = this;
		me.state = "next";
		me.curForm.save2();
	},
	goPrev: function() {
		var me = this;
		if(me.formIds.indexOf(me.curForm.id) == 0){
			return ;
		}
		me.state = "prev";
		var formId = me.formIds[me.formIds.indexOf(me.curForm.id)-1];
		$("#"+me.curForm.id).parent().removeClass("active");
		me.curForm = me.getForm(formId);
		$("#"+me.curForm.id).parent().addClass("active");
		me.fireEvent(IBizWizardPanel.WIZARDFORMCHANGE, me, {formId:me.curForm.id});
	},
	goFinal: function(){
		var me = this;
		me.state = "finish";
		me.curForm.save2();
	}
});
/**
 * 向导完成
 */
IBizWizardPanel.WIZARDFINISH = "WIZARDFINISH";
/**
 * 切换表单
 */
IBizWizardPanel.WIZARDFORMCHANGE = "WIZARDFORMCHANGE";